program testHuffman;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  Classes,
  BitList in 'BitList.pas',
  HuffHelp in 'HuffHelp.pas',
  Huffman in 'Huffman.pas';

type TDuo = record
       word: byte;
       freq: integer;
     end;

var
  InFile, OutFile: TFileStream;
  duolist: array[1..256] of TDuo;
  curFreq: integer;
  numDuo, x, OrigSize: integer;
  info: array[0..1] of byte;
  NumEntries: Byte;
  HuffmanEngine: THuffman;
  CStream, DStream: TMemoryStream;
  FreqList: TList;
begin
  { TODO -oUser -cConsole Main : Insert code here }

  InFile := TFileStream.Create(ParamStr(1),fmOpenRead,fmShareDenyWrite);
  OutFile := TFileStream.Create(ChangeFileExt(ParamStr(1),'.dec'),fmCreate,fmShareExclusive);
  CStream := TMemoryStream.Create;
  HuffmanEngine := THuffman.Create;

  try

{    numDuo := 0;
    curFreq := 1;
    InFile.ReadBuffer(OrigSize,4);
    InFile.ReadBuffer(NumEntries,1);
    InFile.Seek(1032,soFromBeginning);

    for x := 1 to 512 do
    begin
      InFile.ReadBuffer(info,2);
      if info[1] = 1 then
        inc(curFreq)
      else
      begin
        inc(numDuo);
        duolist[numDuo].word := info[0];
        duolist[numDuo].freq := curfreq;
      end;

      if curFreq > numEntries then
        break;

    end;

    with FreqList do
    begin
      Clear;
      for x := 1 to numDuo do
      begin
        writeln(inttohex(duoList[x].word,2)+' '+inttostr(duoList[x].freq));
        Add(THuffNode.CreateAsLeaf(duoList[x].word,duoList[x].freq));
      end;
    end;}

    CStream.CopyFrom(InFile,InFile.Size);
    CStream.Seek(0,SoFromBeginning);
    DStream := HuffManEngine.DeCompressRFD(CStream);
    DStream.Seek(0,SoFromBeginning);
    OutFile.CopyFrom(DStream,DStream.Size);

//    writeln(inttostr(numDuo)+' '+inttostr(NumEntries));

  finally
    InFile.Free;
    HuffmanEngine.Free;
//    FreqList.Free;
    CStream.Free;
    DStream.Free;
    Outfile.Free;
  end;

end.
